var c = Object.defineProperty;
var m = (t, e, s) => e in t ? c(t, e, { enumerable: !0, configurable: !0, writable: !0, value: s }) : t[e] = s;
var o = (t, e, s) => m(t, typeof e != "symbol" ? e + "" : e, s);
var u = /* @__PURE__ */ ((t) => (t.PRIVATE = "WALLET", t.VASP = "VASP", t))(u || {}), E = /* @__PURE__ */ ((t) => (t.NATURAL = "natural", t.LEGAL = "legal", t.SELF = "self", t))(E || {}), f = /* @__PURE__ */ ((t) => (t.EMPTY = "empty", t.VERIFY = "verify", t.PENDING = "pending", t.VERIFIED = "verified", t.BANNED = "banned", t))(f || {}), a = /* @__PURE__ */ ((t) => (t.COMPLETE = "complete", t.RESIZE = "resize", t.RESULT = "result", t.READY = "ready", t.INVALID = "invalid", t.MODAL = "openModal", t.ERROR = "error", t.CLOSE = "closeModal", t.CANCEL = "cancel", t))(a || {}), d = /* @__PURE__ */ ((t) => (t.UPDATE = "update", t.REQUEST_RESPONSE = "requestResponse", t))(d || {}), p = /* @__PURE__ */ ((t) => (t.PENDING = "pending", t.FAILED = "rejected", t.FLAGGED = "flagged", t.VERIFIED = "verified", t))(p || {}), g = /* @__PURE__ */ ((t) => (t.SelfDeclaration = "self-declaration", t.PersonalSignEIP191 = "eip-191", t.PersonalSignEIP712 = "eip-712", t.PersonalSignBIP137 = "bip-137", t.PersonalSignXPUB = "xpub", t.MicroTransfer = "microtransfer", t.Screenshot = "screenshot", t))(g || {});
class v {
  constructor() {
    o(this, "listeners", /* @__PURE__ */ new Map());
    o(this, "port");
    this.handleMessage = this.handleMessage.bind(this);
  }
  setPort(e) {
    this.port = e, this.port.onmessage = this.handleMessage, this.port.start();
  }
  on(e, s) {
    this.listeners.has(e) || this.listeners.set(e, /* @__PURE__ */ new Set()), this.listeners.get(e).add(s);
  }
  off(e, s) {
    const r = this.listeners.get(e);
    r && (r.delete(s), r.size === 0 && this.listeners.delete(e));
  }
  handleMessage(e) {
    const s = e.data;
    if (typeof s == "object" && s !== null && "type" in s) {
      const r = s.type, i = this.listeners.get(r);
      i && i.forEach((n) => n(s));
    }
  }
  // Method to send messages through the port
  send(e) {
    this.port && this.port.postMessage(e);
  }
}
class I {
  /**
   * Creates an instance of EmbeddedComponent.
   * @param url - The URL of the embedded component
   * @param value - The initial transaction value
   */
  constructor(e, s) {
    o(this, "_url");
    o(this, "_value");
    o(this, "_errors", []);
    o(this, "iframe");
    o(this, "eventManager");
    o(this, "modal");
    this._url = e, this._value = s, this.eventManager = new v(), this.on(a.INVALID, (r) => {
      r.type === a.INVALID && (this._errors = r.errors, this._value = r.value);
    }), this.on(a.RESIZE, (r) => {
      r.type === a.RESIZE && this.iframe && (this.iframe.style.height = `${r.height}px`);
    });
  }
  /**
   * Gets the URL of the embedded component
   * @returns The URL of the embedded component
   */
  get url() {
    return this._url;
  }
  /**
   * Gets the current transaction value
   * @returns The current transaction value
   */
  get value() {
    return this._value;
  }
  get errors() {
    return this._errors;
  }
  /**
   * Opens the component URL in the current window
   */
  open() {
    document.location.href = this.url;
  }
  /**
   * Mounts the component to a parent element
   * @param parentId - The ID of the parent element
   * @throws Will throw an error if the parent element is not found
   */
  mount(e) {
    const s = document.querySelector(e);
    if (!s) throw new Error(`parentID ${e} not found`);
    this.embed(s);
  }
  /**
   * Embeds the component into a parent element
   * @param parent - The parent element to embed the component into
   */
  embed(e, s = !1) {
    var r, i;
    this.iframe = document.createElement("iframe"), this.iframe.src = this.url + (s ? "" : "&embedded=true"), this.iframe.allow = "web-share", this.iframe.style.width = "100%", this.iframe.style.height = "100px", this.iframe.style.border = "none", this.iframe.style.overflow = "hidden", e.appendChild(this.iframe), window.addEventListener("message", (n) => {
      var l, h;
      n.source === ((l = this.iframe) == null ? void 0 : l.contentWindow) && ((h = this.eventManager) == null || h.setPort(n.ports[0]));
    }), (i = (r = this.iframe) == null ? void 0 : r.contentWindow) == null || i.focus();
  }
  /**
   * Sends a message to the embedded component
   * @param message - The message to send
   */
  send(e) {
    this.eventManager.send(e);
  }
  /**
   * Adds an event listener for a specific message type
   * @param messageType - The type of message to listen for
   * @param callback - The callback function to execute when the message is received
   */
  on(e, s) {
    this.eventManager.on(e, s);
  }
  /**
   * Removes an event listener for a specific message type
   * @param messageType - The type of message to stop listening for
   * @param callback - The callback function to remove
   */
  off(e, s) {
    this.eventManager.off(e, s);
  }
  /**
   * Updates the transaction value and sends an update message to the component
   * @param value - The new transaction value
   */
  update(e) {
    this._value = e, this.send({ type: d.UPDATE, value: e });
  }
  /**
   * Waits for the component to complete and returns the transaction response
   * @returns A promise that resolves with the transaction response
   */
  completion() {
    return new Promise((e, s) => {
      this.on(a.COMPLETE, (r) => {
        e(r.response);
      }), this.on("error", (r) => {
        s(new Error(r.message));
      });
    });
  }
  /**
   * Opens the component in a modal dialog
   */
  openModal() {
    return this.modal && this.closeModal(), this.modal = document.createElement("dialog"), this.modal.style.border = "none", this.modal.style.backgroundColor = "transparent", this.modal.style.maxWidth = "100vw", this.modal.style.maxHeight = "100vh", this.modal.style.width = "600px", this.modal.style.height = "800px", document.body.appendChild(this.modal), this.embed(this.modal, !0), this.on(a.CANCEL, () => {
      this.closeModal();
    }), this.on(a.CLOSE, () => {
      this.closeModal();
    }), this.on(a.COMPLETE, () => {
      this.closeModal();
    }), this.modal.showModal(), this.modal.addEventListener("click", () => {
      this.closeModal();
    }), this.completion();
  }
  /**
   * Closes the modal dialog
   *
   */
  closeModal() {
    var e;
    this.modal && ((e = this.modal) == null || e.close(), this.modal.remove(), this.modal = void 0);
  }
}
function U(t) {
  return Object.entries(t).map(([e, s]) => {
    if (!(e && s)) return;
    const r = encodeURIComponent(e), i = encodeURIComponent(
      typeof s == "object" ? JSON.stringify(s) : s
    );
    return `${r}=${i}`;
  }).filter((e) => !!e).join("&");
}
class L {
  /**
   * Creates a new instance of the Notabene SDK
   *
   * @param config - Configuration options for the Notabene SDK
   */
  constructor(e) {
    o(this, "nodeUrl");
    o(this, "authToken");
    o(this, "uxUrl");
    o(this, "theme");
    o(this, "locale");
    this.uxUrl = e.uxUrl || "https://connect.notabene.id", this.nodeUrl = e.nodeUrl, this.authToken = e.authToken, this.theme = e.theme, this.locale = e.locale;
  }
  /**
   * Generates a URL for a Notabene component
   *
   * @param path - The path of the component
   * @param value - Transaction data
   * @param configuration - Optional transaction configuration
   * @param callbacks - Optional callback configuration
   * @returns component URL
   * @internal
   */
  componentUrl(e, s, r, i) {
    const n = new URL(this.uxUrl);
    n.pathname = e;
    const l = U({
      authToken: this.authToken,
      value: s,
      configuration: r
    });
    return n.hash = l, this.nodeUrl && n.searchParams.set("nodeUrl", this.nodeUrl), this.theme && n.searchParams.set("theme", JSON.stringify(this.theme)), this.locale && n.searchParams.set("locale", this.locale), i && (i.callback && n.searchParams.set("callback_url", i.callback), i.redirectUri && n.searchParams.set("redirect_uri", i.redirectUri)), n.toString();
  }
  /**
   * Creates a new embedded component
   *
   * @param path - The path of the component
   * @param value - Transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance
   * @internal
   */
  createComponent(e, s, r, i) {
    return new I(
      this.componentUrl(e, s, r, i),
      s
    );
  }
  /**
   * Creates a withdrawal assist component
   *
   * @param value - Withdrawal transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for withdrawal assistance
   */
  createWithdrawalAssist(e, s, r) {
    return this.createComponent("withdrawal-assist", e, s, r);
  }
  /**
   * Creates a wallet assist component
   *
   * @param value - Withdrawal transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for withdrawal assistance
   * @alpha
   */
  createWalletAssist(e, s, r) {
    return this.createComponent("wallet-assist", e, s, r);
  }
  /**
   * Creates a deposit assist component
   *
   * @param value - Deposit transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for deposit assistance
   * @alpha
   */
  createDepositAssist(e, s, r) {
    return this.createComponent(
      "deposit-assist",
      e,
      s,
      r
    );
  }
  /**
   * Creates a connect component
   *
   * @param value - Connection request data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for connection
   * @alpha
   */
  createConnectWallet(e, s, r) {
    return this.createComponent(
      "connect",
      e,
      s,
      r
    );
  }
  /**
   * Creates a deposit request component
   *
   * @param value - Deposit request data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for deposit requests
   * @public
   */
  createDepositRequest(e, s, r) {
    return this.createComponent("deposit-request", e, s, r);
  }
  /**
   * Decodes a URL fragment into an object
   *
   * @param fragment - The URL fragment to decode
   * @returns An object containing the decoded key-value pairs
   */
  decodeFragmentToObject(e) {
    return e.slice(1).split("&").reduce(
      (r, i) => {
        const [n, l] = i.split("=");
        return r[decodeURIComponent(n)] = decodeURIComponent(l), r;
      },
      {}
    );
  }
}
export {
  u as AgentType,
  a as CMType,
  E as PersonType,
  p as ProofStatus,
  g as ProofTypes,
  f as Status,
  L as default
};
