import fc from 'fast-check';
import type { CAIP10, CAIP19, CAIP2, CAIP220 } from '../types';
import {
  CAIP10_MATCHER,
  CAIP19_MATCHER,
  CAIP220_MATCHER,
  CAIP2_MATCHER,
} from './caip';

const LOCALE = new RegExp(/^[a-z]{2}(-[A-Z]{2})?$/);

// Arbitraries
export const arbitraryCAIP10 = (): fc.Arbitrary<CAIP10> =>
  fc.stringMatching(CAIP10_MATCHER) as fc.Arbitrary<CAIP10>;

export const arbitraryCAIP2 = (): fc.Arbitrary<CAIP2> =>
  fc.stringMatching(CAIP2_MATCHER) as fc.Arbitrary<CAIP2>;

export const arbitraryCAIP19 = (): fc.Arbitrary<CAIP19> =>
  fc.stringMatching(CAIP19_MATCHER) as fc.Arbitrary<CAIP19>;

export const arbitraryCAIP220 = (): fc.Arbitrary<CAIP220> =>
  fc.stringMatching(CAIP220_MATCHER) as fc.Arbitrary<CAIP220>;

export const arbitraryLocale = (): fc.Arbitrary<string> =>
  fc.stringMatching(LOCALE) as fc.Arbitrary<string>;
