export function encodeObjectToFragment(obj: any) {
  return Object.entries(obj)
    .map(([key, value]) => {
      if (!(key && value)) return undefined;
      const encodedKey = encodeURIComponent(key);
      const encodedValue = encodeURIComponent(
        typeof value === 'object'
          ? JSON.stringify(value)
          : (value as string | number | boolean),
      );
      return `${encodedKey}=${encodedValue}`;
    })
    .filter((entry) => !!entry)
    .join('&');
}
